
#define sensorPin A0					// Нога для фоторезистора включается в A0 http://goo.gl/9gupvj;
unsigned int sensorValue = 0;			// Переменная для снятия показаний сенсора освещенности;
boolean night = 0;						// Если 1 - то ночь;
byte OutPins[2][15] = {2,3,4,5,6,7,8,9,10,11,12,13,44,45,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // Массив PWM ног, сюда включаются входы http://goo.gl/ZM3xCw;
										// первая строка массива - номер ноги, вторая - состояние, 0 - выключена, 1 - включена;
int i, brightness;						// Счетчики для зажигания и тушения диодов;
unsigned long timeWhenSwitchedOn;		// Сюда помним время, когда включили ступеньки;
int startStep, stopStep, increment;		// Переменные для работы со ступеньками;
boolean measuringDistance = 0;			// Флаги стостояний включения и выключения;
boolean switchingOnNow = 0, switchingOffNow = 0, switchedON = 0; 
#define PING_BOTTOM_PIN 30				// PWM Выход нижний ультрасоник sr04;
#define trigPin00 31					// сюда присоединяем тригерную ногу первого датчика
#define PING_TOP_PIN 32					// PWM Выход верхний ультрасоник sr04;
#define trigPin01 33					// сюда присоединяем тригерную ногу второго датчика
byte trig, ping;
unsigned int  distance=0;				// Дистанция с ультрасоника;
unsigned int duration = 0;				// Для расчета расстояния;
unsigned int a = 0, b = 0;				// Счетчики превышения сенсора над референсным значанием и значением минус гистерезис
boolean distanceFlag = 0;				// Указывает, с верхнего или нижнего ультрасоника поступили данные;
boolean switchFlag = 0;					// Запоминаем, сверху или снизу включать/выключать;
//************************* Все что ниже - определить самостоятельно ************************************************
#define smoothSwitchDelayStep 3			// Скорость нарастания яркости ступеньки мс., чем меньше тем быстрее нарастает;

/*******************************************************************************************************************
Внимание! Ниже SwitchOnBright и decrement - связаные величины. SwitchOnBright должен делиться на decrement без остатка!
Рекомендуется регулировать скорость выключения только этой парой, и лишь в крайнем случае использовать smoothSwitchOffDelayStep.

*******************************************************************************************************************/
#define SwitchOnBright 140				// Яркость включенных ступенек, максимально - 255;
#define fullSwitchedSteps 255			// Яркость включенных ступенек, когда они включаются принудительно с расстояния 5 см., максимально - 255;
#define decrement 3
#define smoothSwitchOffDelayStep 0		// Скорость уменьшения яркости ступеньки мс., чем меньше тем быстрее гаснет, лучше не использовать!;

unsigned int sensorRef = 1020;			// Референсное значение сенсора освещенности, выше которого считается ночь;
#define SwitchOffDelay 15000			// Задержка выключения посветки, милисекунды (здесь 15 секунд) ;
#define NightBright  20					// Яркость подсвеченных ступенек в ночном режиме (первая, последняя);
#define bottomDistance 15				// Расстояние в см для срабатывания нижнего ультрасоника
#define topDistance 15					// Расстояние в см для срабатывания верхнего ультрасоника

//*******************************************************************************************************************
enum {									// Основной цикл состоит из оператора switch, перечислены его шаги;
	GET_BRIGHTNESS,
	GET_DISTANCE,
	SWITCH_ON,
	SWITCH_OFF,
	WHAT_TO_DO,
	FIVE_CM,
} programmSteps;


void setup() {
	Serial.begin(9600);
	
	for(i=0; i<16; i++) {				// Пишем для каждой ступеньки, что она выключена;
		OutPins[1][i] = 0;
		delay(10);
	}
	programmSteps = GET_BRIGHTNESS;		// Начинаем с проверки день/ночь,
	distanceFlag = 0;					// и нижнего ультрасоника;
}

//===================================================================================================================
void loop() 
{
	switch (programmSteps) {
	case GET_BRIGHTNESS:				// Проверка день/ночь;
	
		sensorValue = 0, a = 0, b = 0;				
		sensorValue = analogRead(sensorPin);
		
		if (sensorValue > sensorRef)  {
			programmSteps = GET_DISTANCE;
			Serial.println("Night NOW! ");
			analogWrite(2,NightBright );
			analogWrite(46,NightBright );
			night = 1;
			break;			
		}
		
	for(i = 0; i < 10; i++) {
				sensorValue = analogRead(sensorPin);		// Чтение показаний датчика;
	 			Serial.print("SV: ");
	 			Serial.println(sensorValue);
				if (sensorValue > sensorRef) a++;			// Увеличиваем а, если темнее референсного значения;
				if (sensorValue > (sensorRef - 25)) b++;	// Увеличиваем b, если темнее чем референсное значение минус допуск на гистерезис;
	}
				
			if ((night == 0) && (a > 9)) {					// Если сейчас режим день и 50 раз значение датчика оказалось выше референсного,
				analogWrite(2,NightBright );
				analogWrite(46,NightBright );
				night = 1;
			}
				
			if ((night == 1) && (b == 0)) {					// Если сейчас режим ночь, и 50 раз значение датчика оказалось ниже референсного за
															// вычетом запаса на гистерезис - включаем режим "день", гасим подсветку ступенек.
				analogWrite(2,0);
				analogWrite(46,0);
				night = 0;
			}
															// Куда дальше: ночь - читаем ультрасоники, день - опять проверяем освещение;
		(night) ? programmSteps = GET_DISTANCE : programmSteps = GET_BRIGHTNESS; 
		break;
//===========================================================================================
	case GET_DISTANCE:							// Измерим расстояние;
		if (distanceFlag == 0) 	{				// При каждом входе в проверку выбираем верхний или нижний датчик; 
			trig = trigPin00;
			ping = PING_BOTTOM_PIN;
		}
		else {
			trig = trigPin01;
			ping = PING_TOP_PIN;
		}
		
		delay(5);								// Без этого - не работает; 
	
		  digitalWrite(trig, LOW);
		  delayMicroseconds(2);
		  digitalWrite(trig, HIGH);
		  delayMicroseconds(10);
		  digitalWrite(trig, LOW);
		  duration = pulseIn(ping,HIGH);
		  distance = duration/29/2;
	
		distanceFlag = !distanceFlag;			// Сменили флаг для того, чтобы в следующий раз проверить другой ультрасоник;
		programmSteps = WHAT_TO_DO;				// Идем в "главный мозг" :-)
		break;
	//==============================================================================================
	case WHAT_TO_DO:							// Размышляем, как поступить;
		
		if (distance < 6) {programmSteps = FIVE_CM;} // Если 5 см и меньше на любом ультрасонике - включаем летницу сразу и полностью;
												// Если сработал нижний ультрасоник при выключенной лестнице - вклюаем;
		else if ((distance < bottomDistance) && (distanceFlag) &&(!switchingOnNow) ) {switchFlag = distanceFlag; programmSteps = SWITCH_ON;}
												// Если сработал верхний ультрасоник при выключенной лестнице - вклюаем; 
		else if ((distance < topDistance) && (!distanceFlag)&&(!switchingOnNow) ) {switchFlag = distanceFlag; programmSteps = SWITCH_ON;}	
		
		else if (((millis() - timeWhenSwitchedOn) <SwitchOffDelay) && switchedON) {
    			Serial.print(" millis() - timeWhenSwitchedOn = ");
    			Serial.println(millis() - timeWhenSwitchedOn);
			programmSteps = GET_DISTANCE;}
		else if (((millis() - timeWhenSwitchedOn) >=SwitchOffDelay) && switchedON) {programmSteps = SWITCH_OFF;}
		else {programmSteps = GET_BRIGHTNESS;}
	break;
	
//==============================================================================================
	case SWITCH_ON:	
		brightness = 0;
		
		if (distanceFlag) {
			startStep = 15;
			stopStep = -1;
			increment = -1;
		}
		else {
			startStep = 0;
			stopStep = 16;
			increment = 1;
		}

		for (i=startStep; i != stopStep; i+=increment) {
			if (OutPins[1][i] == 0) {
				for (brightness = 0; brightness <SwitchOnBright; brightness++) {
					analogWrite (OutPins[0][i], brightness);
					delay(smoothSwitchDelayStep);
				}
			}
		}
				
		for(i=0; i<16; i++) {				// Значение ШИМ каждой ступеньки - 0;
			OutPins[1][i] = 1;
			delay(10);
		}
				
		switchedON = 1;
		switchingOffNow = 0;
		timeWhenSwitchedOn = millis();
	programmSteps = GET_DISTANCE;
	break;
//===========================================================================================
	case SWITCH_OFF:
		
		if (!switchingOffNow) {
			switchingOffNow = 1;
			brightness = SwitchOnBright;
			
			if (switchFlag) {
				startStep = 15;
				stopStep = -1;
				increment = -1;
				OutPins[1][startStep]=0;
			} 
			else {
				startStep = 0;
				stopStep = 16;
				increment = 1;
				OutPins[1][startStep]=0;
			}
			
		}
		
		if (startStep != stopStep) {
			brightness -= decrement;
			if (brightness < decrement) {
				brightness = 0;
			}
			if (brightness > -1) {
				analogWrite(OutPins[0][startStep], brightness);
				delay(smoothSwitchOffDelayStep);
			}
			
			if (brightness == 0) {
				startStep  += increment;
				if (startStep != stopStep) {
					OutPins[1][startStep]=0;
				}
				brightness = SwitchOnBright;
			}
			
			if (startStep == stopStep  ) {
				switchedON = 0;
				switchingOffNow = 0;
				analogWrite(OutPins[0][0],NightBright);
				analogWrite(OutPins[0][15], NightBright);
			}
		}
			
	programmSteps = GET_DISTANCE;
	break;
	
//===========================================================================================
	case FIVE_CM:						
	for (i=0; i<16; i++) {						// Зажигаем ступеньки все сразу;
		analogWrite(OutPins[0][i],fullSwitchedSteps);
	}
	delay(800);									// Убрали ботинок с 5 см.
	trig = 30;								
	
	do {										// Проверяем расстояние на ультрасониках;
		if (distanceFlag == 0) 	{				// При каждом входе в проверку выбираем верхний или нижний датчик; 
			trig = trigPin00;
			ping = PING_BOTTOM_PIN;
		}
		else {
			trig = trigPin01;
			ping = PING_TOP_PIN;
                 }
		delay(100);								// Немного ждем, чтобы не перегружать ультрасоники;						
		pinMode(trig, OUTPUT);				// Типичный алгоритм проверки ультрасоника, см. документацию;
		  digitalWrite(trig, LOW);
		  delayMicroseconds(2);
		  digitalWrite(trig, HIGH);
		  delayMicroseconds(10);
		  digitalWrite(trig, LOW);
		  duration = pulseIn(ping,HIGH);
		  distance = duration/29/2;
		
	} while (distance > 7);						// Измеряем до тех пор, пока расстояние больше 7 см.
	for (i=0; i<16; i++) {						// Гасим ступеньки, обнуляем контрольные ячейки включения;
		analogWrite(OutPins[0][i],0);
		OutPins[1][i]=0;
	}
	analogWrite(OutPins[0][0],NightBright);		// Подсвечиваем первую и последнюю ступеньки;
	analogWrite(OutPins[0][15], NightBright);
	
	delay(3000);								// Подождем, чтобы самим убраться из зоны действия датчика;
	programmSteps = GET_DISTANCE;
	break;
	}
}

